#include "utils.PRO2"
#include "ArbreN.hpp"
#include "ArbreNIOint.hpp"


int altura(ArbreNari<int>& a)
/* Pre: a=A */
{
  if (a.es_buit()) return 0;
  else{
    vector<ArbreNari<int> > v;
    a.fills(v);
    int m=0;
    for (int i=0; i<v.size(); ++i){
      int k= altura(v[i]);
      if (m < k) m=k;
    }
    return m+1;
  }
}
/* Post: El resultat és la longitud del camí més llarg de l'arrel a una fulla 
   de l'arbre A; a és buit */


/* Pre: a=A , b = B , a i b mateixa aritat */
bool iguals(ArbreNari<int> &a, ArbreNari<int> &b){
  if (a.es_buit() and b.es_buit()) return true;
  if (a.es_buit() or b.es_buit()) return false;
  else {
    if (a.arrel() != b.arrel()) return false;
    else{
      vector<ArbreNari<int> > va;
      vector<ArbreNari<int> > vb;
      a.fills(va);
      b.fills(vb);
      for (int i=0; i<va.size(); ++i){
	if (not iguals(va[i],vb[i])) return false;
      }
      return true;
    }
  }
}
// Post: retorna si A i B són iguals o no




int main() {
  int n;
  cin>> n;
  ArbreNari<int> a(n); 
  llegir_arbreN_int(a,0);
  ArbreNari<int> c(a);  
  cout << "Altura: " << altura(c) << endl;
  cin>> n;
  ArbreNari<int> b(n);  
  llegir_arbreN_int(b,0);
  c=a;
  escriure_arbreN_int(c);
  cout << endl;
  c=b;
  escriure_arbreN_int(c);
  cout << endl;
  bool ig;
  if (a.aritat()!=b.aritat()) ig=false;
  else ig =iguals(a,b);
  if (ig) cout << "Són iguals" << endl;
  else cout << "No són iguals" << endl;

}
